unit Child;

interface

uses
    Windows, Classes, SysUtils, Graphics, Forms, Controls, StdCtrls,
  ExtCtrls, ComCtrls;

type
  TChildForm = class(TForm)
    Panel1: TPanel;
    EditRowCount: TEdit;
    UpdnRowCount: TUpDown;
    Label1: TLabel;
    MemoTail: TMemo;
    Label2: TLabel;
    Label3: TLabel;
    LblSize: TLabel;
    LblModified: TLabel;
    Timer: TTimer;
    Label4: TLabel;
    LblRowCount: TLabel;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormActivate(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure TimerTimer(Sender: TObject);
  private
    TargetSize: integer;
    TargetModified: TDateTime;
    TargetRowCount: integer;
  public
    TargetFile: string;
    procedure OnChangeMethod();
  end;

implementation

{$R *.dfm}

uses
    Main, fjUtil;

//-----------------------------------------------------------------------------
//  Őݒ
procedure TChildForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
    Action := caFree;
end;

//-----------------------------------------------------------------------------
//  EBhEIXg폜
procedure TChildForm.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
    Timer.Enabled := False;
    MainForm.CallOnReleaseMDIChild(Self);
end;

//-----------------------------------------------------------------------------
//  EBhEIXgŎI
procedure TChildForm.FormActivate(Sender: TObject);
begin
    MainForm.CallOnActivateMDIChild(Self);
end;

//-----------------------------------------------------------------------------
//  tH[쐬
procedure TChildForm.FormCreate(Sender: TObject);
begin
    //  oϐ
    TargetSize := 0;
    TargetModified := 0;
    TargetRowCount := 0;
end;

//-----------------------------------------------------------------------------
//  tH[j
procedure TChildForm.FormDestroy(Sender: TObject);
begin
    //
end;

//-----------------------------------------------------------------------------
//  ύX`FbN
procedure TChildForm.OnChangeMethod();
var
    OldSize: integer;
    OldModified: TDateTime;
    OldRowCount: integer;
begin
    //  Ώۃt@C̑݃`FbN
    if FileExists(TargetFile) then
    begin
        //  obNAbv
        OldSize     := TargetSize;
        OldModified := TargetModified;
        OldRowCount := TargetRowCount;

        //  TCY擾
        TargetSize := FileSizeByFileStream(TargetFile);

        //  ύX擾
        TargetModified := FileModifiedByGetFileTime(TargetFile);

        //  ύXĂ邩H
        if (OldSize <> TargetSize) or (OldModified <> TargetModified) then
        begin
            //  \
            Tail(TargetFile, MemoTail.Lines, UpdnRowCount.Position, TargetRowCount);

            //  ߂Ă̏ꍇ͒
            if (OldSize = 0) then OldSize := TargetSize;
            if (OldModified = 0) then OldModified := TargetModified;
            if (OldRowCount = 0) then OldRowCount := TargetRowCount;

            //  \-2
            LblSize.Caption := Format('%s (%s)', [
                                    SizeText(TargetSize),
                                    SizeText(TargetSize - OldSize)
                                ]);

            LblModified.Caption := Format('%s (%s)', [
                                    DateText(TargetModified),
                                    DateText(OldModified, TargetModified)
                                ]);

            LblRowCount.Caption := Format('%d LL (%d LL)', [
                                    TargetRowCount,
                                    TargetRowCount - OldRowCount
                                ]);
        end;
    end;
end;

//-----------------------------------------------------------------------------
//  ύXĎ
procedure TChildForm.TimerTimer(Sender: TObject);
begin
    Timer.Enabled := False;
    OnChangeMethod();
    Timer.Enabled := True;
end;

end.
